CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  LED1  = 16
  LED2  = 23

  CR    = $0D

VAR
  long  rate[2]
  long  stack1[10]
  long  stack2[10]

OBJ
  serial : "FullDuplexSerial"

 
PUB Main | id, len, value, i
  serial.start(31, 30, 0, 115200)

  'Initial blink rate
  rate[0] := 1
  rate[1] := 1

  'Start Toggle processes
  cognew(Toggle1, @stack1)
  cognew(Toggle2, @stack2)

  'Get the packet parameters
  repeat
    value := 0
    repeat until serial.rxcheck == "!"
    id := serial.Rx
    len := serial.Rx
    repeat i from 0 to len-1
      value |= serial.Rx << (i * 8)

    'The command should end with an $0D
    if(serial.Rx <> CR)
      next 
      
  
    if(id == 1)
      rate[id-1] := value 
      serial.str(string("ID1 : Value "))
      serial.Dec(value)
        
    if(id == 2)
      rate[id-1] := value
      serial.str(string("ID2 : Value "))
      serial.Dec(value)


PUB Toggle1
  dira[LED1]~~
  repeat
    !outa[LED1]
    waitcnt(80_000_000/(4 * rate[0])  + cnt)

PUB Toggle2
  dira[LED2]~~
  repeat
    !outa[LED2]
    waitcnt(80_000_000/(4 * rate[1])  + cnt)
